src/Concerto/PanelBundle/Entity/User.php
<?php

namespace Concerto\PanelBundle\Entity;

use Doctrine\ORM\Mapping as ORM;
use Symfony\Component\Security\Core\User\EquatableInterface;
use Symfony\Component\Security\Core\User\UserInterface;
use Symfony\Component\Validator\Constraints as Assert;
use Symfony\Component\Security\Core\User\AdvancedUserInterface;
use Doctrine\Common\Collections\ArrayCollection;
use Symfony\Bridge\Doctrine\Validator\Constraints\UniqueEntity;
use Scheb\TwoFactorBundle\Model\Google\TwoFactorInterface;

/**
 * @ORM\Table(name="ConcertoUser")
 * @ORM\Entity(repositoryClass="Concerto\PanelBundle\Repository\UserRepository")
 * @UniqueEntity(fields="username", message="validate.user.username.unique")
 * @UniqueEntity(fields="email", message="validate.user.email.unique")
 */
class User extends ATopEntity implements AdvancedUserInterface, \Serializable, \JsonSerializable, EquatableInterface, TwoFactorInterface
{
    const ROLE_SUPER_ADMIN = "ROLE_SUPER_ADMIN";
    const ROLE_TEST = "ROLE_TEST";
    const ROLE_TABLE = "ROLE_TABLE";
    const ROLE_TEMPLATE = "ROLE_TEMPLATE";
    const ROLE_WIZARD = "ROLE_WIZARD";
    const ROLE_FILE = "ROLE_FILE";

    const LOCK_DURATION = 60 * 5;
    const LOCK_STREAK = 3;

    /**
     * @var string
     * @Assert\Length(min="3", max="25", minMessage="validate.user.username.min", maxMessage="validate.user.username.max")
     * @Assert\NotBlank(message="validate.user.username.blank")
     * @ORM\Column(type="string", length=25, unique=true)
     */
    private $username;

    /**
     * @var string
     *
     * @ORM\Column(type="string", length=32)
     */
    private $salt;

    /**
     * @var string
     * @Assert\Length(min="4", max="40", minMessage="validate.user.password.min", maxMessage="validate.user.password.max")
     * @Assert\NotBlank(message="validate.user.password.blank", groups={"create"});
     * @ORM\Column(type="string", length=40)
     */
    private $password;

    /**
     *
     * @var string
     */
    private $passwordConfirmation;

    /**
     * @var string
     *
     * @ORM\Column(type="string", length=60, unique=true)
     * @Assert\Email(message="validate.user.email")
     * @Assert\Length(max="60",maxMessage="validate.user.email.max")
     * @Assert\NotBlank(message="validate.user.email.blank")
     */
    private $email;

    /**
     * @ORM\ManyToMany(targetEntity="Role", inversedBy="users")
     */
    private $roles;

    /**
     * @var integer
     * @ORM\Column(type="integer")
     */
    private $failedAuthenticationStreak;

    /**
     * @var \DateTime|null
     * @ORM\Column(type="datetime", nullable=true)
     */
    private $lockedUntil;

    /**
     * @ORM\Column(type="boolean")
     */
    private $googleAuthenticatorEnabled;

    /**
     * @ORM\Column(type="string", nullable=true)
     */
    private $googleAuthenticatorSecret;

    /**
     * Constructor
     */
    public function __construct()
    {
        parent::__construct();

        $this->roles = new ArrayCollection();
        $this->salt = md5(uniqid(null, true));
        $this->failedAuthenticationStreak = 0;
        $this->googleAuthenticatorEnabled = false;
    }

    /**
     * @inheritDoc
     */
    public function eraseCredentials()
    {

    }

    /**
     * @inheritDoc
     */
    public function getPassword()
    {
        return $this->password;
    }

    /**
     * @inheritDoc
     */
    public function getRoles()
    {
        return $this->roles->toArray();
    }

    /**
     * @inheritDoc
     */
    public function getSalt()
    {
        return $this->salt;
    }

    /**
     * @inheritDoc
     */
    public function getUsername()
    {
        return $this->username;
    }

    /**
     * @see \Serializable::serialize()
     */
    public function serialize()
    {
        return serialize(array(
            $this->id,
            $this->username,
            $this->password,
            $this->salt
        ));
    }

    /**
     * @see \Serializable::unserialize()
     */
    public function unserialize($serialized)
    {
        list (
            $this->id,
            $this->username,
            $this->password,
            $this->salt
            ) = unserialize($serialized);
    }

    /**
     * Set username
     *
     * @param string $username
     * @return User
     */
    public function setUsername($username)
    {
        $this->username = $username;

        return $this;
    }

    /**
     * Set salt
     *
     * @param string $salt
     * @return User
     */
    public function setSalt($salt)
    {
        $this->salt = $salt;

        return $this;
    }

    /**
     * Set password
     *
     * @param string $password
     * @return User
     */
    public function setPassword($password)
    {
        $this->password = $password;

        return $this;
    }

    /**
     * Set password confirmation
     *
     * @param string $passwordConfirmation
     * @return User
     */
    public function setPasswordConfirmation($passwordConfirmation)
    {
        $this->passwordConfirmation = $passwordConfirmation;

        return $this;
    }

    /**
     * Set email
     *
     * @param string $email
     * @return User
     */
    public function setEmail($email)
    {
        $this->email = $email;

        return $this;
    }

    /**
     * Get email
     *
     * @return string
     */
    public function getEmail()
    {
        return $this->email;
    }

    /**
     * Add roles
     *
     * @param Role $roles
     * @return User
     */
    public function addRole(Role $roles)
    {
        $this->roles[] = $roles;

        return $this;
    }

    /**
     * Remove roles
     *
     * @param Role $roles
     */
    public function removeRole(Role $roles)
    {
        $this->roles->removeElement($roles);
    }

    /**
     * Checks if the user has role
     *
     * @param Role $role
     * @return boolean
     */
    public function hasRole(Role $role)
    {
        return $this->roles->contains($role);
    }

    /**
     * Checks if the user has role
     *
     * @param string $roleName
     * @return boolean
     */
    public function hasRoleName($roleName)
    {
        foreach ($this->roles as $role) {
            if ($role->getName() == $roleName)
                return true;
        }
        return false;
    }

    /**
     * Checks if password is correct by comparing password and password confirmation
     *
     * @return boolean
     * @Assert\IsTrue(message = "validate.user.password.match", groups={"create"})
     */
    public function isPasswordCorrect()
    {
        return $this->password === $this->passwordConfirmation;
    }

    public function isAccountNonExpired()
    {
        return true;
    }

    public function isAccountNonLocked()
    {
        return $this->lockedUntil === null || time() > $this->lockedUntil->getTimestamp();
    }

    public function isCredentialsNonExpired()
    {
        return true;
    }

    public function isEnabled()
    {
        return !$this->archived;
    }

    /**
     * @return \DateTime|null
     */
    public function getLockedUntil()
    {
        return $this->lockedUntil;
    }

    /**
     * @param \DateTime|null $lockedUntil
     * @return User
     */
    public function setLockedUntil($lockedUntil)
    {
        $this->lockedUntil = $lockedUntil;
        return $this;
    }

    /**
     * @return int
     */
    public function getFailedAuthenticationStreak()
    {
        return $this->failedAuthenticationStreak;
    }

    /**
     * @param int $streak
     * @return User
     */
    public function setFailedAuthenticationStreak($streak)
    {
        $this->failedAuthenticationStreak = $streak;
        return $this;
    }

    public function isGoogleAuthenticatorEnabled(): bool
    {
        return $this->googleAuthenticatorEnabled;
    }

    public function setGoogleAuthenticatorEnabled($enabled)
    {
        $this->googleAuthenticatorEnabled = $enabled;
        return $this;
    }

    public function getGoogleAuthenticatorUsername(): string
    {
        return "Concerto (" . $this->username . "@" . $_SERVER["HTTP_HOST"] . ")";
    }

    public function getGoogleAuthenticatorSecret(): ?string
    {
        return $this->googleAuthenticatorSecret;
    }

    public function setGoogleAuthenticatorSecret(?string $googleAuthenticatorSecret): void
    {
        $this->googleAuthenticatorSecret = $googleAuthenticatorSecret;
    }

    public function __toString()
    {
        return "User (id: " . $this->getId() . ", username:" . $this->getUsername() . ")";
    }

    public function getOwner()
    {
        return $this;
    }

    public function isEqualTo(UserInterface $user)
    {
        if ($this->password !== $user->getPassword()) {
            return false;
        }

        if ($this->salt !== $user->getSalt()) {
            return false;
        }

        if ($this->username !== $user->getUsername()) {
            return false;
        }

        return true;
    }

    public function getEntityHash()
    {
        return null;
    }

    public function jsonSerialize(&$dependencies = array())
    {
        return array(
            "class_name" => "User",
            "id" => $this->id,
            "accessibility" => $this->accessibility,
            "archived" => $this->archived ? "1" : "0",
            "username" => $this->username,
            "email" => $this->email,
            "updatedOn" => $this->updated->getTimestamp(),
            "updatedBy" => $this->updatedBy,
            "lockedBy" => $this->getLockBy() ? $this->getLockBy()->getId() : null,
            "directLockBy" => $this->getDirectLockBy() ? $this->getDirectLockBy()->getId() : null,
            "role_super_admin" => $this->hasRoleName(self::ROLE_SUPER_ADMIN) ? "1" : "0",
            "role_test" => $this->hasRoleName(self::ROLE_TEST) ? "1" : "0",
            "role_template" => $this->hasRoleName(self::ROLE_TEMPLATE) ? "1" : "0",

src/Concerto/PanelBundle/Resources/views/DataTable/data_section.html.twig
{% extends "::base_include.html.twig" %}
{% set class_name = "DataTable" %}
{% trans_default_domain "DataTable" %}

{% block content %}
    <div class="center">
        <button ng-click="fetchDataCollection(object.id);" class="btn btn-default btn-sm">{{ "list.button.refresh"|trans({}, "panel") }}</button>
        <button class="btn btn-success btn-sm" ng-click="addRow()" ng-disabled="!isEditable()">{{ 'data.list.add'|trans }}</button>
        <button class="btn btn-danger btn-sm" ng-click="deleteSelectedRows()" ng-disabled="!isEditable()">{{ 'data.list.delete.checked'|trans }}</button>
        <button class="btn btn-danger btn-sm" ng-click="deleteAllRows()" ng-disabled="!isEditable()">{{ 'data.list.delete.all'|trans }}</button>
        <button ng-click="downloadDataList()" class="btn btn-default btn-sm">{{ "list.button.download"|trans({},"panel") }}</button>
    </div>
    <div ui-grid="dataOptions" ui-grid-edit ui-grid-row-edit ui-grid-pagination ui-grid-auto-resize ui-grid-cellNav ui-grid-resize-columns ui-grid-exporter ui-grid-selection ui-grid-move-columns class="grid"></div>
{% endblock %}

src/Concerto/PanelBundle/Resources/views/DataTable/form.html.twig
{% extends "ConcertoPanelBundle::form_h.html.twig" %}
{% set class_name = "DataTable" %}
{% trans_default_domain "DataTable" %}
{% set exportable = true %}

{% block top %}
    {{ include("ConcertoPanelBundle::lock_info.html.twig") }}
{% endblock %}
{% block legend %}
    {% verbatim %}{{formTitle}}{% endverbatim %}
{% endblock %}
{% block elements %}
    {% embed "ConcertoPanelBundle::form_h_element.html.twig" %}
        {% trans_default_domain "DataTable" %}
        {% block label %}{{ 'form.field.name'|trans }}{% endblock %}
        {% block tooltip %}{{'form.field.name.tooltip'|trans}}{% endblock %}
        {% block control %}
            <input ng-disabled="!isEditable()" type="text" ng-model="object.name" style="width:100%;" class='form-control' ng-model-options='{ updateOn: "blur" }' />
        {% endblock %}
    {% endembed %}

    {% embed "ConcertoPanelBundle::form_h_element.html.twig" %}
        {% trans_default_domain "DataTable" %}
        {% block label %}{{ 'form.field.archived'|trans }}{% endblock %}
        {% block tooltip %}{{'form.field.archived.tooltip'|trans}}{% endblock %}
        {% block control %}
            <input type="checkbox" ng-disabled="!isEditable()"  ng-model="object.archived" ng-true-value="'1'" ng-false-value="'0'">
        {% endblock %}
    {% endembed %}
    
    {% if app.user and is_granted('ROLE_SUPER_ADMIN') %}
        {% embed "ConcertoPanelBundle::form_h_element.html.twig" %}
            {% trans_default_domain "DataTable" %}
            {% block label %}{{ 'form.field.accessibility'|trans }}{% endblock %}
            {% block tooltip %}{{'form.field.accessibility.tooltip'|trans}}{% endblock %}
            {% block control %}
                <select ng-disabled="!isEditable()" ng-model="object.accessibility" style="width:100%;" ng-options="accessibility.value as accessibility.label for accessibility in accessibilities" class='form-control'>
                </select>
            {% endblock %}
        {% endembed %}

        {% embed "ConcertoPanelBundle::form_h_element.html.twig" %}
            {% trans_default_domain "DataTable" %}
            {% block label %}{{ 'form.field.owner'|trans }}{% endblock %}
            {% block tooltip %}{{'form.field.owner.tooltip'|trans}}{% endblock %}
            {% block control %}
                <select ng-disabled="!isEditable()" ng-model="object.owner" style="width:100%;" ng-options="owner.id as owner.username for owner in userCollectionService.collection | filter : {'archived':'!1'} | orderBy: 'username' " class='form-control'>
                    <option value="">{{"none.choosen"|trans({},"panel")}}</option>
                </select>
            {% endblock %}
        {% endembed %}

        {% embed "ConcertoPanelBundle::form_h_element.html.twig" %}
            {% trans_default_domain "DataTable" %}
            {% block label %}{{ 'form.field.groups'|trans }}{% endblock %}
            {% block tooltip %}{{'form.field.groups.tooltip'|trans}}{% endblock %}
            {% block control %}
                <input ng-disabled="!isEditable()" type="text" ng-model="object.groups" style="width:100%;" class='form-control' ng-model-options='{ updateOn: "blur" }' />
            {% endblock %}
        {% endembed %}
    {% endif %}
    
{% endblock %}

{% block sections %}
    <uib-accordion-group is-open="tabAccordion.structure.open">
        <uib-accordion-heading>
            <i class="glyphicon glyphicon-info-sign" uib-tooltip-html="'{{ 'structure.fieldset.legend.tooltip'|trans }}'"></i>
            {{ 'structure.fieldset.legend'|trans }}
            <i class="pull-right glyphicon" ng-class="{'glyphicon-chevron-down': tabAccordion.structure.open, 'glyphicon-chevron-right': !tabAccordion.structure.open}"></i>
        </uib-accordion-heading>
        {{ include("ConcertoPanelBundle:DataTable:structure_section.html.twig", {'class_name':"DataTable"}) }}
    </uib-accordion-group>

    <uib-accordion-group is-open="tabAccordion.data.open">
        <uib-accordion-heading>
            <i class="glyphicon glyphicon-info-sign" uib-tooltip-html="'{{ 'data.fieldset.legend.tooltip'|trans }}'"></i>
            {{ 'data.fieldset.legend'|trans }}
            <i class="pull-right glyphicon" ng-class="{'glyphicon-chevron-down': tabAccordion.data.open, 'glyphicon-chevron-right': !tabAccordion.data.open}"></i>
        </uib-accordion-heading>
        {{ include("ConcertoPanelBundle:DataTable:data_section.html.twig") }}
    </uib-accordion-group>
{% endblock %}

{% block floatingBarButtons %}
    <button ng-disabled="!isEditable()" class='btn btn-success' ng-click="persist();">{{ 'form.button.save'|trans({},"panel") }}</button>
    <button class="btn btn-success" ng-click="importCsv()" ng-disabled="!isEditable()">{{ 'form.button.import.csv'|trans }}</button>
    <button class='btn btn-warning' ng-click="cancel();">{{ 'form.button.cancel'|trans({},"panel") }}</button>
    <button class='btn btn-success' ng-click="saveNew();">{{ 'form.button.save.new'|trans({},"panel") }}</button>
    <button class="btn btn-default" ng-click="exportObject();">{{ 'form.button.export'|trans({},"panel") }}</button>
    <button class="btn btn-default" ng-show="!isLocked()" ng-disabled="!isEditable()" ng-click="toggleLock()"><i class="glyphicon glyphicon-lock"></i>{{ 'form.button.lock'|trans({},"panel") }}</button>
    <button class="btn btn-default" ng-show="isLocked()" ng-disabled="!isEditable()" ng-click="toggleLock()"><i class="glyphicon glyphicon-lock"></i>{{ 'form.button.unlock'|trans({},"panel") }}</button>
    <button ng-disabled="!isEditable()" class='btn btn-danger' ng-click="deleteObject();">{{ 'form.button.delete'|trans({},"panel") }}</button>
{% endblock %}

src/Concerto/PanelBundle/Resources/views/DataTable/structure_section.html.twig
{% extends "::base_include.html.twig" %}
{% trans_default_domain "DataTable" %}

{% block content %}
    <div class="center">
        <button ng-disabled="!isEditable()" class="btn btn-success btn-sm" ng-click="addStructure()">{{ 'structure.list.add'|trans }}</button>
        <button ng-click="gridService.downloadList(structureGridApi);" class="btn btn-default btn-sm">{{ "list.button.download"|trans({},"panel") }}</button>
        <button ng-disabled="!isEditable()" class="btn btn-danger btn-sm" ng-click="deleteSelectedStructure()">{{ 'structure.list.delete.checked'|trans }}</button>
    </div>
    <div ui-grid="structureOptions" ui-grid-auto-resize ui-grid-resize-columns ui-grid-exporter ui-grid-selection ui-grid-move-columns class="grid"></div>
{% endblock %}